/* $Id: samp1.cpp,v 1.2 1995/09/23 21:24:25 artc Exp $ */
//  samp1.cpp
// This program demonstrates iterating over a symbol table...specifically
// the linetype table.


#include <stdlib.h>
#include <rxobject.h>
#include <rxregsvc.h>
#include <aced.h>
#include <dbsymtb.h>
#include <adslib.h>

// function prototypes

void iterate_linetypes();
void initApp();
void unloadApp();
extern "C" AcRx::AppRetCode acrxEntryPoint(AcRx::AppMsgCode, void*);


// Opens the linetype table and iterates through all the entries
// printing the name of each linetype.
//
void
iterate_linetypes()
{
    AcDbLinetypeTable *pLinetypeTbl;

   	// get the linetypeTable
   	//
   	acdbCurDwg()->getLinetypeTable(pLinetypeTbl, AcDb::kForRead);
   
   	// create a new iterator that starts at table beginning and skips deleted
   	//
   	AcDbLinetypeTableIterator *pLtIterator;
   	pLinetypeTbl->newIterator(pLtIterator);

   	// walk the table getting every table record and printing the linetype name
   	//
   	AcDbLinetypeTableRecord *pLtTableRcd;
	char *pLtName = (char *) malloc(34);
   	for(; !pLtIterator->done(); pLtIterator->step()) {
   	  
	  	// get the current record and open it for read
   	  	//
   	  	pLtIterator->getRecord(AcDb::kForRead, pLtTableRcd);

	  	// get the linetype name
	  	//
	  	pLtTableRcd->getName(pLtName);

		// close the linetype record
		//
		pLtTableRcd->close();
	  
	  	// print the linetype name
	  	//
	  	ads_printf("\nLinetype name is:  %s", pLtName);
   	}

	// delete the iterator
	//
	delete pLtIterator;

	// close the linetype table
	//
	pLinetypeTbl->close();

	// free the pLtName string memory
	//
	free (pLtName);
}


// Initialization function called from acrxEntryPoint during kInitAppMsg
// case.  This function is used to add commands to the command stack.
//
void
initApp()
{
    acedRegCmds->addCommand("TABLETEST_COMMANDS", "ITERATE", "ITERATE",
        ACRX_CMD_MODAL, &iterate_linetypes);
}


// Clean up function called from acrxEntryPoint during the kUnloadAppMsg
// case.  This function removes this apps command set from the command
// stack.
//
void
unloadApp()
{
    acedRegCmds->removeGroup("TABLETEST_COMMANDS");
}


// ARX entry point
//
AcRx::AppRetCode
acrxEntryPoint(AcRx::AppMsgCode msg, void* pkt)
{
    switch(msg) {
    case AcRx::kInitAppMsg:
	    acrxDynamicLinker->unlockApplication(pkt);
        initApp();
        break;
    case AcRx::kUnloadAppMsg:
        unloadApp();
        break;
    case AcRx::kLoadADSMsg:
    case AcRx::kUnloadADSMsg:
    default:
        break;
    }
    return AcRx::kRetOK;
}
