/* $Id: rxhello1.cpp,v 1.1 1994/10/18 16:25:16 edwardb Exp $ */
/* 
      (C) Copyright 1993-1994 by Autodesk, Inc.

******************************************************************************
*                                                                            *
* The information contained herein is confidential, proprietary to Autodesk, *
* Inc., and considered a trade secret as defined in section 499C of the      *
* penal code of the State of California.  Use of this information by anyone  *
* other than authorized employees of Autodesk, Inc. is granted only under a  *
* written non-disclosure agreement, expressly prescribing the scope and      *
* manner of such use.                                                        *
*                                                                            *
******************************************************************************/

/*
	rxhello1.cpp

	The absolute minimal Rx program.
	Say 'hello' to all the messages received by acrxEntryPoint.
	No objects, no methods, no nothing except hello.

	Jeremy Tammik, Autodesk ESC, 93-11-15

	93-11-30: removed initModule and syncModule functions,
		replaced them by acrxEntryPoint.
	94-03-14: recompiled for Dream Team release,
		added #pragma to disable 'pack(1)' warning
		.. later replaced by RADPACK
	94-08-08: recompiled for r072,
		added export of _SetacrxPtp
*/
#include <rxdefs.h> // AcRx msg codes
#include <adslib.h> // ads_printf

extern "C" AcRx::AppRetCode acrxEntryPoint ( 
	AcRx::AppMsgCode msg, 
	void* 
)
{
	switch(msg) {
	case AcRx::kNullMsg:
		ads_printf ("Rx Hello 1 -- kNullMsg\n");
		break;
	case AcRx::kInitAppMsg:
		ads_printf ("Rx Hello 1 -- kInitAppMsg\n");
		break;
	case AcRx::kUnloadAppMsg:
		ads_printf ("Rx Hello 1 -- kUnloadAppMsg\n");
		break;
	case AcRx::kLoadADSMsg:
		ads_printf ("Rx Hello 1 -- kLoadADSMsg\n");
		break;
	case AcRx::kUnloadADSMsg:
		ads_printf ("Rx Hello 1 -- kUnloadADSMsg\n");
		break;
	default:
		ads_printf ("Rx Hello 1 -- <unknown message %d>\n", msg);
		break;
	}
	return AcRx::kRetOK;
}
