/* $Id: rxhello2.cpp,v 1.1 1994/10/18 16:25:40 edwardb Exp $ */
/* 
      (C) Copyright 1993-1994 by Autodesk, Inc.

******************************************************************************
*                                                                            *
* The information contained herein is confidential, proprietary to Autodesk, *
* Inc., and considered a trade secret as defined in section 499C of the      *
* penal code of the State of California.  Use of this information by anyone  *
* other than authorized employees of Autodesk, Inc. is granted only under a  *
* written non-disclosure agreement, expressly prescribing the scope and      *
* manner of such use.                                                        *
*                                                                            *
******************************************************************************/

/*
	rxhello2.cpp

	The minimal Rx program defining an AutoCAD command
	HELLO2 which says hello.

	Jeremy Tammik, Autodesk ESC, 93-11-19
*/
#include <aced.h> // AcEdStuff
#include <adslib.h> // ads_printf

// hello2 - main action here, AutoCAD command:

void hello2 ()
{
	ads_printf ("This is hello2() in RxHello2: Hi!\n");
}

void initApp()
{
	ads_printf( "Rx Hello 2 Client -- initApp\n" );
	acedRegCmds->addCommand( "HELLO2_COMMANDS", "HELLO2", 
		"HELLO2", ACRX_CMD_MODAL, &hello2 );
}

void unloadApp()
{
	ads_printf( "Rx Hello 2 -- unloadApp\n");
	acedRegCmds->removeGroup( "HELLO2_COMMANDS" );
}

extern "C" AcRx::AppRetCode acrxEntryPoint (AcRx::AppMsgCode msg, void*)
{
	switch(msg) {
	case AcRx::kInitAppMsg: initApp(); break;
	case AcRx::kUnloadAppMsg: unloadApp(); break;
	case AcRx::kLoadADSMsg:
		ads_printf ("Rx Hello 2 -- kLoadADSMsg\n");
		break;
	case AcRx::kUnloadADSMsg:
		ads_printf ("Rx Hello 2 -- kUnloadADSMsg\n");
		break;
	default:
		ads_printf ("Rx Hello 2 -- <unknown message %d>\n", msg);
		break;
	}
	return AcRx::kRetOK;
}
