
//
// $Id: acdbabb.h,v 1.72 1995/12/20 15:11:14 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary
// to Autodesk,  Inc.,	and considered a trade secret as defined
// in section 499C of the penal code of the State of California.
// Use of  this information  by  anyone  other	than  authorized
// employees of Autodesk, Inc.	is granted  only under a written
// non-disclosure agreement,  expressly  prescribing  the  scope
// and manner of such use.
//
// acdbabb.h:	Abbreviations for definitions in acdb.h
// 2/21/94: Up to date with respect to acdb.h


#ifdef AD_ACDBABB_H
// This file should only be included by .c?? files.  If it's
// included twice, we assume it's because it is being included
// by .h file(s), and so we complain.
#error "acdbabb.h included more than once!  Is it included by a .h file?"
#endif

#define _AD_ACDBABB_H 1

#include "acdb.h"

typedef Acad::ErrorStatus	ErrorStatus;

//typedef AcDb::BChunk		BChunk;
typedef AcDb::OpenMode	        OpenMode;
typedef AcDb::FileVersion	FileVersion;
typedef AcDb::OsnapMode 	OsnapMode;
typedef AcDb::CoordAxis 	CoordAxis;
typedef AcDb::CoordSystem	CoordSystem;
typedef AcDb::Intersect 	Intersect;
typedef AcDb::Visibility	Visibility;
typedef AcDb::SaveType		SaveType;
typedef AcDb::DxfCode		DxfCode;
typedef AcDb::DwgDataType	DwgDataType;
//typedef AcDb::DwgField		DwgField;
//typedef AcDb::ResBuf		ResBuf;
typedef AcDb::TextHorzMode	TextHorzMode;
typedef AcDb::TextVertMode	TextVertMode;
typedef AcDb::Planarity 	Planarity;
typedef AcDb::PointIndex	PointIndex;
typedef AcDb::EdgeIndex 	EdgeIndex;
typedef AcDb::Poly2dType	Poly2dType;
typedef AcDb::Poly3dType	Poly3dType;
typedef AcDb::PolyMeshType	PolyMeshType;
typedef AcDb::Vertex2dType	Vertex2dType;
typedef AcDb::Vertex3dType	Vertex3dType;
typedef AcDb::SpaceValueType	SpaceValueType;
typedef AcDb::BoolOperType      BoolOperType;
typedef AcDb::SubentType        SubentType;
typedef AcDb::GeomId            GeomId;
typedef AcDb::GeomType          GeomType;



// enum Acad::ErrorStatus

const Acad::ErrorStatus eOk = Acad::eOk;
const Acad::ErrorStatus eNotImplementedYet = Acad::eNotImplementedYet;
const Acad::ErrorStatus eNotApplicable = Acad::eNotApplicable;
const Acad::ErrorStatus eInvalidInput = Acad::eInvalidInput;
const Acad::ErrorStatus eAmbiguousInput = Acad::eAmbiguousInput;
const Acad::ErrorStatus eAmbiguousOutput = Acad::eAmbiguousOutput;
const Acad::ErrorStatus eOutOfMemory = Acad::eOutOfMemory;
const Acad::ErrorStatus eBufferTooSmall = Acad::eBufferTooSmall;
const Acad::ErrorStatus eInvalidOpenState = Acad::eInvalidOpenState;
const Acad::ErrorStatus eHandleExists = Acad::eHandleExists;
const Acad::ErrorStatus eNullHandle = Acad::eNullHandle;
const Acad::ErrorStatus eBrokenHandle = Acad::eBrokenHandle;
const Acad::ErrorStatus eUnknownHandle = Acad::eUnknownHandle;
const Acad::ErrorStatus eHandleInUse = Acad::eHandleInUse;
const Acad::ErrorStatus eNullObjectPointer = Acad::eNullObjectPointer;
const Acad::ErrorStatus eNullObjectId = Acad::eNullObjectId;
const Acad::ErrorStatus eNullBlockName = Acad::eNullBlockName;
const Acad::ErrorStatus eNullEntityPointer = Acad::eNullEntityPointer;
const Acad::ErrorStatus eIllegalEntityType = Acad::eIllegalEntityType;
const Acad::ErrorStatus eKeyNotFound = Acad::eKeyNotFound;
const Acad::ErrorStatus eDuplicateKey = Acad::eDuplicateKey;
const Acad::ErrorStatus eInvalidIndex = Acad::eInvalidIndex;
const Acad::ErrorStatus eDuplicateIndex = Acad::eDuplicateIndex;
const Acad::ErrorStatus eAlreadyInDb = Acad::eAlreadyInDb;
const Acad::ErrorStatus eOutOfDisk = Acad::eOutOfDisk;
const Acad::ErrorStatus eDeletedEntry = Acad::eDeletedEntry;
const Acad::ErrorStatus eNegativeValueNotAllowed = Acad::eNegativeValueNotAllowed;
const Acad::ErrorStatus eInvalidExtents = Acad::eInvalidExtents;
const Acad::ErrorStatus eInvalidAdsName = Acad::eInvalidAdsName;
const Acad::ErrorStatus eInvalidKey = Acad::eInvalidKey;
const Acad::ErrorStatus eEndOfObject = Acad::eEndOfObject;
const Acad::ErrorStatus eEndOfFile = Acad::eEndOfFile;
const Acad::ErrorStatus eObjectToBeDeleted = Acad::eObjectToBeDeleted;
const Acad::ErrorStatus eInvalidDwgVersion = Acad::eInvalidDwgVersion;
const Acad::ErrorStatus eAnonymousEntry = Acad::eAnonymousEntry;
const Acad::ErrorStatus eIllegalReplacement = Acad::eIllegalReplacement;
const Acad::ErrorStatus eIsReading = Acad::eIsReading;
const Acad::ErrorStatus eIsWriting = Acad::eIsWriting;
const Acad::ErrorStatus eNotOpenForRead = Acad::eNotOpenForRead;
const Acad::ErrorStatus eNotOpenForWrite = Acad::eNotOpenForWrite;
const Acad::ErrorStatus eNotThatKindOfClass = Acad::eNotThatKindOfClass;
const Acad::ErrorStatus eInvalidDxfCode = Acad::eInvalidDxfCode;
const Acad::ErrorStatus eInvalidResBuf = Acad::eInvalidResBuf;
const Acad::ErrorStatus eBadDxfSequence = Acad::eBadDxfSequence;
const Acad::ErrorStatus eInvalidBlockName = Acad::eInvalidBlockName;
const Acad::ErrorStatus eMissingDxfField  = Acad::eMissingDxfField;
const Acad::ErrorStatus eDuplicateDxfField = Acad::eDuplicateDxfField;
const Acad::ErrorStatus eFilerError = Acad::eFilerError;
const Acad::ErrorStatus eVertexAfterFace = Acad::eVertexAfterFace;
const Acad::ErrorStatus eInvalidFaceVertexIndex = Acad::eInvalidFaceVertexIndex;
const Acad::ErrorStatus eInvalidMeshVertexIndex = Acad::eInvalidMeshVertexIndex;
const Acad::ErrorStatus eOtherObjectsBusy = Acad::eOtherObjectsBusy;
const Acad::ErrorStatus eMustFirstAddBlockToDb = Acad::eMustFirstAddBlockToDb;
const Acad::ErrorStatus eCannotNestBlockDefs = Acad::eCannotNestBlockDefs;
const Acad::ErrorStatus eDwgRecoveredOK = Acad::eDwgRecoveredOK;
const Acad::ErrorStatus eDwgNotRecoverable = Acad::eDwgNotRecoverable;
const Acad::ErrorStatus eDwgNeedsRecovery = Acad::eDwgNeedsRecovery;
const Acad::ErrorStatus eDeleteEntity = Acad::eDeleteEntity;
const Acad::ErrorStatus eInvalidFix = Acad::eInvalidFix;
const Acad::ErrorStatus eFSMError = Acad::eFSMError;
const Acad::ErrorStatus eDxfPartiallyRead = Acad::eDxfPartiallyRead;
const Acad::ErrorStatus eMissingSymbolTable = Acad::eMissingSymbolTable;
const Acad::ErrorStatus eMissingSymbolTableRec = Acad::eMissingSymbolTableRec;
const Acad::ErrorStatus eDwgCRCDoesNotMatch = Acad::eDwgCRCDoesNotMatch;
const Acad::ErrorStatus eDwgSentinelDoesNotMatch =
                            Acad::eDwgSentinelDoesNotMatch;
const Acad::ErrorStatus eDwgObjectImproperlyRead =
                            Acad::eDwgObjectImproperlyRead;
const Acad::ErrorStatus eNoInputFiler = Acad::eNoInputFiler;
const Acad::ErrorStatus eDwgNeedsAFullSave = Acad::eDwgNeedsAFullSave;
const Acad::ErrorStatus eDxfReadAborted = Acad::eDxfReadAborted;
const Acad::ErrorStatus eDxbPartiallyRead = Acad::eDxbPartiallyRead;
const Acad::ErrorStatus eDxbReadAborted = Acad::eDxbReadAborted;
const Acad::ErrorStatus eFileLockedByACAD = Acad::eFileLockedByACAD;
const Acad::ErrorStatus eFileAccessErr = Acad::eFileAccessErr;
const Acad::ErrorStatus eFileSystemErr = Acad::eFileSystemErr;
const Acad::ErrorStatus eFileInternalErr = Acad::eFileInternalErr;
const Acad::ErrorStatus eWasErased = Acad::eWasErased;
const Acad::ErrorStatus ePermanentlyErased = Acad::ePermanentlyErased;
const Acad::ErrorStatus eWasOpenForRead = Acad::eWasOpenForRead;
const Acad::ErrorStatus eWasOpenForWrite = Acad::eWasOpenForWrite;
const Acad::ErrorStatus eWasOpenForUndo = Acad::eWasOpenForUndo;
const Acad::ErrorStatus eWasNotifying = Acad::eWasNotifying;
const Acad::ErrorStatus eWasOpenForNotify = Acad::eWasOpenForNotify;
const Acad::ErrorStatus eOnLockedLayer = Acad::eOnLockedLayer;
const Acad::ErrorStatus eMustOpenThruOwner = Acad::eMustOpenThruOwner;
const Acad::ErrorStatus eSubentitiesStillOpen = Acad::eSubentitiesStillOpen;
const Acad::ErrorStatus eAtMaxReaders = Acad::eAtMaxReaders;
const Acad::ErrorStatus eIsWriteProtected = Acad::eIsWriteProtected;
const Acad::ErrorStatus eIsXRefObject = Acad::eIsXRefObject;
const Acad::ErrorStatus eNotAnEntity = Acad::eNotAnEntity;
const Acad::ErrorStatus eHadMultipleReaders = Acad::eHadMultipleReaders;
const Acad::ErrorStatus eWasNotOpenForWrite = Acad::eWasNotOpenForWrite;
const Acad::ErrorStatus eCloseWasNotifying = Acad::eCloseWasNotifying;
const Acad::ErrorStatus eCloseModifyAborted = Acad::eCloseModifyAborted;
const Acad::ErrorStatus eClosePartialFailure = Acad::eClosePartialFailure;
const Acad::ErrorStatus eCannotBeErasedByCaller = Acad::eCannotBeErasedByCaller;
const Acad::ErrorStatus eFixedAllErrors = Acad::eFixedAllErrors;
const Acad::ErrorStatus eLeftErrorsUnfixed = Acad::eLeftErrorsUnfixed;
const Acad::ErrorStatus eUnrecoverableErrors = Acad::eUnrecoverableErrors;
const Acad::ErrorStatus eNoDatabase = Acad::eNoDatabase;
const Acad::ErrorStatus eXdataSizeExceeded = Acad::eXdataSizeExceeded;
const Acad::ErrorStatus eRegappIdNotFound = Acad::eRegappIdNotFound;
const Acad::ErrorStatus eRepeatEntity = Acad::eRepeatEntity;
const Acad::ErrorStatus eRecordNotInTable = Acad::eRecordNotInTable;
const Acad::ErrorStatus eIteratorDone = Acad::eIteratorDone;
const Acad::ErrorStatus eNotInBlock = Acad::eNotInBlock;
const Acad::ErrorStatus eGeneralModelingFailure = Acad::eGeneralModelingFailure;
const Acad::ErrorStatus eOutOfRange = Acad::eOutOfRange;
const Acad::ErrorStatus eNonCoplanarGeometry = Acad::eNonCoplanarGeometry;
const Acad::ErrorStatus eDegenerateGeometry  = Acad::eDegenerateGeometry;
const Acad::ErrorStatus eOwnerNotInDatabase = Acad::eOwnerNotInDatabase;
const Acad::ErrorStatus eOwnerNotOpenForRead = Acad::eOwnerNotOpenForRead;
const Acad::ErrorStatus eOwnerNotOpenForWrite = Acad::eOwnerNotOpenForWrite;
const Acad::ErrorStatus eExplodeBeforeTransform = Acad::eExplodeBeforeTransform;
const Acad::ErrorStatus eCannotScaleNonUniformly = Acad::eCannotScaleNonUniformly;
const Acad::ErrorStatus eNotInDatabase = Acad::eNotInDatabase;
const Acad::ErrorStatus eNotCurrentDatabase = Acad::eNotCurrentDatabase;
const Acad::ErrorStatus eIsAnEntity = Acad::eIsAnEntity;
const Acad::ErrorStatus eCannotChangeActiveViewport = Acad::eCannotChangeActiveViewport;
const Acad::ErrorStatus eNotInPaperspace = Acad::eNotInPaperspace;
const Acad::ErrorStatus eCommandWasInProgress = Acad::eCommandWasInProgress;
const Acad::ErrorStatus eInvalidAxis  = Acad::eInvalidAxis;
const Acad::ErrorStatus ePointNotOnEntity  = Acad::ePointNotOnEntity;
const Acad::ErrorStatus eSingularPoint  = Acad::eSingularPoint;
const Acad::ErrorStatus eInvalidOffset = Acad::eInvalidOffset;
const Acad::ErrorStatus eStringTooLong  = Acad::eStringTooLong;
const Acad::ErrorStatus eNullIterator = Acad::eNullIterator;
const Acad::ErrorStatus eInvalidSymbolTableName = Acad::eInvalidSymbolTableName;
const Acad::ErrorStatus eDuplicateRecordName = Acad::eDuplicateRecordName;
const Acad::ErrorStatus eXRefDependent = Acad::eXRefDependent;
const Acad::ErrorStatus eSelfReference = Acad::eSelfReference;
const Acad::ErrorStatus eWrongDatabase = Acad::eWrongDatabase;
const Acad::ErrorStatus eWrongObjectType = Acad::eWrongObjectType;
const Acad::ErrorStatus eInvalidSymTableFlag = Acad::eInvalidSymTableFlag;
const Acad::ErrorStatus eUndefinedLineType = Acad::eUndefinedLineType;
const Acad::ErrorStatus eInvalidTextStyle = Acad::eInvalidTextStyle;
const Acad::ErrorStatus eTooFewLineTypeElements = Acad::eTooFewLineTypeElements;
const Acad::ErrorStatus eTooManyLineTypeElements = Acad::eTooManyLineTypeElements;
const Acad::ErrorStatus eExcessiveItemCount = Acad::eExcessiveItemCount;
const Acad::ErrorStatus eIgnoredLinetypeRedef = Acad::eIgnoredLinetypeRedef;
const Acad::ErrorStatus eBadUCS = Acad::eBadUCS;
const Acad::ErrorStatus eBadPaperspaceView = Acad::eBadPaperspaceView;
const Acad::ErrorStatus eSomeInputDataLeftUnread=Acad::eSomeInputDataLeftUnread;
const Acad::ErrorStatus eNoInternalSpace=Acad::eNoInternalSpace;
const Acad::ErrorStatus eInvalidDimStyle = Acad::eInvalidDimStyle;
const Acad::ErrorStatus eInvalidLayer = Acad::eInvalidLayer;
const Acad::ErrorStatus eUserBreak = Acad::eUserBreak;

const Acad::ErrorStatus eBadLayerName = Acad::eBadLayerName;
const Acad::ErrorStatus eLayerGroupCodeMissing = Acad::eLayerGroupCodeMissing;
const Acad::ErrorStatus eBadColorIndex = Acad::eBadColorIndex;
const Acad::ErrorStatus eBadLinetypeName = Acad::eBadLinetypeName;
const Acad::ErrorStatus eBadLinetypeScale = Acad::eBadLinetypeScale;
const Acad::ErrorStatus eBadVisibilityValue = Acad::eBadVisibilityValue;
const Acad::ErrorStatus eProperClassSeparatorExpected = Acad::eProperClassSeparatorExpected;
const Acad::ErrorStatus ePagerError = Acad::ePagerError;
const Acad::ErrorStatus eOutOfPagerMemory = Acad::eOutOfPagerMemory;
const Acad::ErrorStatus ePagerWriteError = Acad::ePagerWriteError;
const Acad::ErrorStatus eWasNotForwarding = Acad::eWasNotForwarding;
const Acad::ErrorStatus eInvalidIdMap = Acad::eInvalidIdMap;
const Acad::ErrorStatus eInvalidOwnerObject = Acad::eInvalidOwnerObject;
const Acad::ErrorStatus eOwnerNotSet = Acad::eOwnerNotSet;
const Acad::ErrorStatus eNoActiveTransactions = Acad::eNoActiveTransactions; 
const Acad::ErrorStatus eNotTopTransaction = Acad::eNotTopTransaction; 
const Acad::ErrorStatus eTransactionOpenWhileCommandEnded = 
                        Acad::eTransactionOpenWhileCommandEnded;
const Acad::ErrorStatus eInProcessOfCommitting = 
                        Acad::eInProcessOfCommitting;
const Acad::ErrorStatus eNotNewlyCreated = Acad::eNotNewlyCreated;
const Acad::ErrorStatus eAlreadyInGroup = Acad::eAlreadyInGroup;
const Acad::ErrorStatus eNotInGroup = Acad::eNotInGroup;
const Acad::ErrorStatus eWrongSubentityType = Acad::eWrongSubentityType;
const Acad::ErrorStatus eInvalidStyle = Acad::eInvalidStyle;
const Acad::ErrorStatus eCannotRestoreFromAcisFile = Acad::eCannotRestoreFromAcisFile;
const Acad::ErrorStatus eNonPlanarEntity = Acad::eNonPlanarEntity;
const Acad::ErrorStatus eCannotExplodeEntity = Acad::eCannotExplodeEntity;
// enum AcDb::OpenMode

const AcDb::OpenMode kForRead = AcDb::kForRead;
const AcDb::OpenMode kForWrite = AcDb::kForWrite;
const AcDb::OpenMode kForNotify = AcDb::kForNotify;

// enum AcDb::SaveImagesMode

const AcDb::SaveImagesMode kUseDefaultSave = AcDb::kUseDefaultSave;
const AcDb::SaveImagesMode kAlwaysSave     = AcDb::kAlwaysSave;
const AcDb::SaveImagesMode kNeverSave      = AcDb::kNeverSave;
// enum AcDb::FileVersion

const AcDb::FileVersion kR12 = AcDb::kR12;
const AcDb::FileVersion kR13 = AcDb::kR13;
const AcDb::FileVersion kR13Custom = AcDb::kR13Custom;
const AcDb::FileVersion kMaxVersion = AcDb::kMaxVersion;

// enum AcDb::CoordAxis

const AcDb::CoordAxis kX = AcDb::kX;
const AcDb::CoordAxis kY = AcDb::kY;
const AcDb::CoordAxis kZ = AcDb::kZ;

// enum AcDb::CoordSystem

const AcDb::CoordSystem kWorldCS = AcDb::kWorldCS;
const AcDb::CoordSystem kUserCS = AcDb::kUserCS;
const AcDb::CoordSystem kCurDisplayCS = AcDb::kCurDisplayCS;
const AcDb::CoordSystem kPaperDisplayCS = AcDb::kPaperDisplayCS;
const AcDb::CoordSystem kEntityCS = AcDb::kEntityCS;

// enum AcDb::Intersect

const AcDb::Intersect kOnBothOperands = AcDb::kOnBothOperands;
const AcDb::Intersect kExtendThis = AcDb::kExtendThis;
const AcDb::Intersect kExtendArg = AcDb::kExtendArg;
const AcDb::Intersect kExtendBoth = AcDb::kExtendBoth;

// enum AcDb::Visibility

const AcDb::Visibility kInvisible = AcDb::kInvisible;
const AcDb::Visibility kVisible = AcDb::kVisible;

// enum AcDb::DxfCode

const AcDb::DxfCode kDxfInvalid = AcDb::kDxfInvalid;
const AcDb::DxfCode kDxfXDictionary = AcDb::kDxfXDictionary;
const AcDb::DxfCode kDxfPReactors = AcDb::kDxfPReactors;
const AcDb::DxfCode kDxfUndo = AcDb::kDxfUndo;
const AcDb::DxfCode kDxfXDataStart = AcDb::kDxfXDataStart;
const AcDb::DxfCode kDxfHeaderId = AcDb::kDxfHeaderId;
const AcDb::DxfCode kDxfEnd = AcDb::kDxfEnd;
const AcDb::DxfCode kDxfStart = AcDb::kDxfStart;
const AcDb::DxfCode kDxfText = AcDb::kDxfText;
const AcDb::DxfCode kDxfShapeName = AcDb::kDxfShapeName;
const AcDb::DxfCode kDxfSymbolTableName = AcDb::kDxfSymbolTableName;
const AcDb::DxfCode kDxfBlockName = AcDb::kDxfBlockName;
const AcDb::DxfCode kDxfAttributeTag = AcDb::kDxfAttributeTag;
const AcDb::DxfCode kDxfAttributePrompt = AcDb::kDxfAttributePrompt;
const AcDb::DxfCode kDxfDimStyleName = AcDb::kDxfDimStyleName;
const AcDb::DxfCode kDxfXRefPath = AcDb::kDxfXRefPath;
const AcDb::DxfCode kDxfHandle = AcDb::kDxfHandle;
const AcDb::DxfCode kDxfLinetypeName = AcDb::kDxfLinetypeName;
const AcDb::DxfCode kDxfTextStyleName = AcDb::kDxfTextStyleName;
const AcDb::DxfCode kDxfCLShapeText = AcDb:: kDxfCLShapeText;
const AcDb::DxfCode kDxfCLShapeName = AcDb::kDxfCLShapeName;
const AcDb::DxfCode kDxfLayerName = AcDb::kDxfLayerName;
const AcDb::DxfCode kDxfXCoord = AcDb::kDxfXCoord;
const AcDb::DxfCode kDxfYCoord = AcDb::kDxfYCoord;
const AcDb::DxfCode kDxfZCoord = AcDb::kDxfZCoord;
const AcDb::DxfCode kDxfElevation = AcDb::kDxfElevation;
const AcDb::DxfCode kDxfThickness = AcDb::kDxfThickness;
const AcDb::DxfCode kDxfReal = AcDb::kDxfReal;
const AcDb::DxfCode kDxfXReal = AcDb::kDxfXReal;
const AcDb::DxfCode kDxfInt8 = AcDb::kDxfInt8;
const AcDb::DxfCode kDxfLinetypeScale = AcDb::kDxfLinetypeScale;
const AcDb::DxfCode kDxfLinetypeElement = AcDb::kDxfLinetypeElement;
const AcDb::DxfCode kDxfAngle = AcDb::kDxfAngle;
const AcDb::DxfCode kDxfVisibility = AcDb::kDxfVisibility;
const AcDb::DxfCode kDxfLayerLinetype = AcDb::kDxfLayerLinetype;
const AcDb::DxfCode kDxfColor = AcDb::kDxfColor;
const AcDb::DxfCode kDxfHasSubentities = AcDb::kDxfHasSubentities;
const AcDb::DxfCode kDxfViewportVisibility = AcDb::kDxfViewportVisibility;
const AcDb::DxfCode kDxfViewportActive = AcDb::kDxfViewportActive;
const AcDb::DxfCode kDxfViewportNumber = AcDb::kDxfViewportNumber;
const AcDb::DxfCode kDxfInt16 = AcDb::kDxfInt16;
const AcDb::DxfCode kDxfXInt16 = AcDb::kDxfXInt16;
const AcDb::DxfCode kDxfXXInt16 = AcDb::kDxfXXInt16;
const AcDb::DxfCode kDxfInt32 = AcDb::kDxfInt32;
const AcDb::DxfCode kDxfControlString = AcDb::kDxfControlString;
const AcDb::DxfCode kDxfDimVarHandle = AcDb::kDxfDimVarHandle;
const AcDb::DxfCode kDxfSubclass = AcDb::kDxfSubclass;
const AcDb::DxfCode kDxfNormalX = AcDb::kDxfNormalX;
const AcDb::DxfCode kDxfNormalY = AcDb::kDxfNormalY;
const AcDb::DxfCode kDxfNormalZ = AcDb::kDxfNormalZ;
const AcDb::DxfCode kDxfXTextString = AcDb::kDxfXTextString;
const AcDb::DxfCode kDxfBinaryChunk = AcDb::kDxfBinaryChunk;
const AcDb::DxfCode kDxfArbHandle   = AcDb::kDxfArbHandle;
const AcDb::DxfCode kDxfSoftPointerId = AcDb::kDxfSoftPointerId;
const AcDb::DxfCode kDxfHardPointerId = AcDb::kDxfHardPointerId;
const AcDb::DxfCode kDxfSoftOwnershipId = AcDb::kDxfSoftOwnershipId;
const AcDb::DxfCode kDxfHardOwnershipId = AcDb::kDxfHardOwnershipId;
const AcDb::DxfCode kDxfComment = AcDb::kDxfComment;
const AcDb::DxfCode kDxfXdAsciiString = AcDb::kDxfXdAsciiString;
const AcDb::DxfCode kDxfRegAppName = AcDb::kDxfRegAppName;
const AcDb::DxfCode kDxfXdControlString = AcDb::kDxfXdControlString;
const AcDb::DxfCode kDxfXdLayerName = AcDb::kDxfXdLayerName;
const AcDb::DxfCode kDxfXdBinaryChunk = AcDb::kDxfXdBinaryChunk;
const AcDb::DxfCode kDxfXdHandle = AcDb::kDxfXdHandle;
const AcDb::DxfCode kDxfXdXCoord = AcDb::kDxfXdXCoord;
const AcDb::DxfCode kDxfXdYCoord = AcDb::kDxfXdYCoord;
const AcDb::DxfCode kDxfXdZCoord = AcDb::kDxfXdZCoord;
const AcDb::DxfCode kDxfXdWorldXCoord = AcDb::kDxfXdWorldXCoord;
const AcDb::DxfCode kDxfXdWorldYCoord = AcDb::kDxfXdWorldYCoord;
const AcDb::DxfCode kDxfXdWorldZCoord = AcDb::kDxfXdWorldZCoord;
const AcDb::DxfCode kDxfXdWorldXDisp = AcDb::kDxfXdWorldXDisp;
const AcDb::DxfCode kDxfXdWorldYDisp = AcDb::kDxfXdWorldYDisp;
const AcDb::DxfCode kDxfXdWorldZDisp = AcDb::kDxfXdWorldZDisp;
const AcDb::DxfCode kDxfXdWorldXDir = AcDb::kDxfXdWorldXDir;
const AcDb::DxfCode kDxfXdWorldYDir = AcDb::kDxfXdWorldYDir;
const AcDb::DxfCode kDxfXdWorldZDir = AcDb::kDxfXdWorldZDir;
const AcDb::DxfCode kDxfXdReal = AcDb::kDxfXdReal;
const AcDb::DxfCode kDxfXdDist = AcDb::kDxfXdDist;
const AcDb::DxfCode kDxfXdScale = AcDb::kDxfXdScale;
const AcDb::DxfCode kDxfXdInteger16 = AcDb::kDxfXdInteger16;
const AcDb::DxfCode kDxfXdInteger32 = AcDb::kDxfXdInteger32;

// enum AcDb::DwgDataType

const AcDb::DwgDataType kDwgNull = AcDb::kDwgNull;
const AcDb::DwgDataType kDwgReal = AcDb::kDwgReal;
const AcDb::DwgDataType kDwgInt32 = AcDb::kDwgInt32;
const AcDb::DwgDataType kDwgInt16 = AcDb::kDwgInt16;
const AcDb::DwgDataType kDwgInt8 = AcDb::kDwgInt8;
const AcDb::DwgDataType kDwgText = AcDb::kDwgText;
const AcDb::DwgDataType kDwgBChunk = AcDb::kDwgBChunk;
const AcDb::DwgDataType kDwgHandle = AcDb::kDwgHandle;
const AcDb::DwgDataType kDwgHardOwnershipId = AcDb::kDwgHardOwnershipId;
const AcDb::DwgDataType kDwgSoftOwnershipId = AcDb::kDwgSoftOwnershipId;
const AcDb::DwgDataType kDwgHardPointerId   = AcDb::kDwgHardPointerId;
const AcDb::DwgDataType kDwgSoftPointerId   = AcDb::kDwgSoftPointerId;
const AcDb::DwgDataType kDwg3Real = AcDb::kDwg3Real;
const AcDb::DwgDataType kDwgNotRecognized = AcDb::kDwgNotRecognized;

// enum AcDb::OsnapMask

const AcDb::OsnapMask kOsMaskEnd = AcDb::kOsMaskEnd;
const AcDb::OsnapMask kOsMaskMid = AcDb::kOsMaskMid;
const AcDb::OsnapMask kOsMaskCen = AcDb::kOsMaskCen;
const AcDb::OsnapMask kOsMaskNode = AcDb::kOsMaskNode;
const AcDb::OsnapMask kOsMaskQuad = AcDb::kOsMaskQuad;
const AcDb::OsnapMask kOsMaskInt = AcDb::kOsMaskInt;
const AcDb::OsnapMask kOsMaskIns = AcDb::kOsMaskIns;
const AcDb::OsnapMask kOsMaskPerp = AcDb::kOsMaskPerp;
const AcDb::OsnapMask kOsMaskTan = AcDb::kOsMaskTan;
const AcDb::OsnapMask kOsMaskNear = AcDb::kOsMaskNear;
const AcDb::OsnapMask kOsMaskQuick = AcDb::kOsMaskQuick;
const AcDb::OsnapMask kOsMaskImmediate = AcDb::kOsMaskImmediate;
const AcDb::OsnapMask kOsMaskAllowTan = AcDb::kOsMaskAllowTan;
const AcDb::OsnapMask kOsMaskDisablePerp = AcDb::kOsMaskDisablePerp;
const AcDb::OsnapMask kOsMaskRelCartesian = AcDb::kOsMaskRelCartesian;
const AcDb::OsnapMask kOsMaskRelPolar = AcDb::kOsMaskRelPolar;

// enum AcDb::OsnapMode

const AcDb::OsnapMode kOsModeEnd = AcDb::kOsModeEnd;
const AcDb::OsnapMode kOsModeMid = AcDb::kOsModeMid;
const AcDb::OsnapMode kOsModeCen = AcDb::kOsModeCen;
const AcDb::OsnapMode kOsModeNode = AcDb::kOsModeNode;
const AcDb::OsnapMode kOsModeQuad = AcDb::kOsModeQuad;
const AcDb::OsnapMode kOsModeIns = AcDb::kOsModeIns;
const AcDb::OsnapMode kOsModePerp = AcDb::kOsModePerp;
const AcDb::OsnapMode kOsModeTan = AcDb::kOsModeTan;
const AcDb::OsnapMode kOsModeNear = AcDb::kOsModeNear;

// enum AcDb::TextHorzMode

const AcDb::TextHorzMode kTextLeft = AcDb::kTextLeft;
const AcDb::TextHorzMode kTextCenter = AcDb::kTextCenter;
const AcDb::TextHorzMode kTextRight = AcDb::kTextRight;
const AcDb::TextHorzMode kTextAlign = AcDb::kTextAlign;
const AcDb::TextHorzMode kTextMid = AcDb::kTextMid;
const AcDb::TextHorzMode kTextFit = AcDb::kTextFit;

// enum AcDb::TextVertMode

const AcDb::TextVertMode kTextBase = AcDb::kTextBase;
const AcDb::TextVertMode kTextBottom = AcDb::kTextBottom;
const AcDb::TextVertMode kTextVertMid = AcDb::kTextVertMid;
const AcDb::TextVertMode kTextTop = AcDb::kTextTop;

// enum AcDb::Planarity

const AcDb::Planarity kNonPlanar = AcDb::kNonPlanar;
const AcDb::Planarity kPlanar = AcDb::kPlanar;
const AcDb::Planarity kLinear = AcDb::kLinear;

// enum AcDb::PointIndex

const AcDb::PointIndex kMPoint1 = AcDb::kMPoint1;
const AcDb::PointIndex kMPoint2 = AcDb::kMPoint2;
const AcDb::PointIndex kMPoint3 = AcDb::kMPoint3;
const AcDb::PointIndex kMPoint4 = AcDb::kMPoint4;

// enum AcDb::EdgeIndex

const AcDb::EdgeIndex kMEdge1 = AcDb::kMEdge1;
const AcDb::EdgeIndex kMEdge2 = AcDb::kMEdge2;
const AcDb::EdgeIndex kMEdge3 = AcDb::kMEdge3;
const AcDb::EdgeIndex kMEdge4 = AcDb::kMEdge4;

// enum AcDb::Poly2dType

const AcDb::Poly2dType k2dSimplePoly = AcDb::k2dSimplePoly;
const AcDb::Poly2dType k2dFitCurvePoly = AcDb::k2dFitCurvePoly;
const AcDb::Poly2dType k2dQuadSplinePoly = AcDb::k2dQuadSplinePoly;
const AcDb::Poly2dType k2dCubicSplinePoly = AcDb::k2dCubicSplinePoly;

// enum AcDb::Poly3dType

const AcDb::Poly3dType k3dSimplePoly = AcDb::k3dSimplePoly;
const AcDb::Poly3dType k3dQuadSplinePoly = AcDb::k3dQuadSplinePoly;
const AcDb::Poly3dType k3dCubicSplinePoly = AcDb::k3dCubicSplinePoly;

// enum AcDb::PolyMeshType

const AcDb::PolyMeshType kSimpleMesh = AcDb::kSimpleMesh;
const AcDb::PolyMeshType kQuadSurfaceMesh = AcDb::kQuadSurfaceMesh;
const AcDb::PolyMeshType kCubicSurfaceMesh = AcDb::kCubicSurfaceMesh;
const AcDb::PolyMeshType kBezierSurfaceMesh = AcDb::kBezierSurfaceMesh;

// enum AcDb::Vertex2dType

const AcDb::Vertex2dType k2dVertex = AcDb::k2dVertex;
const AcDb::Vertex2dType k2dSplineCtlVertex = AcDb::k2dSplineCtlVertex;
const AcDb::Vertex2dType k2dSplineFitVertex = AcDb::k2dSplineFitVertex;
const AcDb::Vertex2dType k2dCurveFitVertex = AcDb::k2dCurveFitVertex;

// enum AcDb::Vertex3dType

const AcDb::Vertex3dType k3dSimpleVertex = AcDb::k3dSimpleVertex;
const AcDb::Vertex3dType k3dControlVertex = AcDb::k3dControlVertex;
const AcDb::Vertex3dType k3dFitVertex = AcDb::k3dFitVertex;

// enum AcDb::SpaceValueType

const AcDb::SpaceValueType kUndefined = AcDb::kUndefined;
const AcDb::SpaceValueType kStubPtr = AcDb::kStubPtr;
const AcDb::SpaceValueType kEndOfFile = AcDb::kEndOfFile;
const AcDb::SpaceValueType kBackwardBranch = AcDb::kBackwardBranch;
const AcDb::SpaceValueType kForwardBranch = AcDb::kForwardBranch;
const AcDb::SpaceValueType kDetour = AcDb::kDetour;

// enum AcDb::BoolOperType

const AcDb::BoolOperType kBoolUnite = AcDb::kBoolUnite;
const AcDb::BoolOperType kBoolIntersect = AcDb::kBoolIntersect;
const AcDb::BoolOperType kBoolSubtract = AcDb::kBoolSubtract;

// enum AcDb::SubentType

const AcDb::SubentType kNullSubentType   = AcDb::kNullSubentType;
const AcDb::SubentType kVertexSubentType = AcDb::kVertexSubentType;
const AcDb::SubentType kEdgeSubentType   = AcDb::kEdgeSubentType;
const AcDb::SubentType kFaceSubentType   = AcDb::kFaceSubentType;

// enum AcDb::GeomId

const AcDb::GeomId kNoGeom = AcDb::kNoGeom;

// enum AcDb::GeomType

const AcDb::GeomType kInvalidGeom = AcDb::kInvalidGeom;
const AcDb::GeomType kPointGeom = AcDb::kPointGeom;
const AcDb::GeomType kLineGeom = AcDb::kLineGeom;
const AcDb::GeomType kCircleGeom = AcDb::kCircleGeom;
const AcDb::GeomType kPlaneGeom = AcDb::kPlaneGeom;
