#ifndef ACDB_AUTIL_H
#define ACDB_AUTIL_H
//
// $Id: dbautil.h,v 1.8 1995/10/26 16:13:41 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary
// to Autodesk,  Inc.,	and considered a trade secret as defined
// in section 499C of the penal code of the State of California.
// Use of  this information  by  anyone  other	than  authorized
// employees of Autodesk, Inc.	is granted  only under a written
// non-disclosure agreement,  expressly  prescribing  the  scope
// and manner of such use.

#include "adesk.h"
#include "ads.h"

class AcGeMatrix3d;

// ADS input options
//
#define INP_NNULL     0x01
#define INP_NZERO     0x02
#define INP_NNEG      0x04
#define INP_NLIM      0x08
#define INP_DASH      0x20
#define INP_NZCOORD   0x40

// ADS redraw types
//
#define RD_DRAW       1
#define RD_ERASE      2
#define RD_HILITE     3
#define RD_UNHI       4

Adesk::Boolean acdbWcs2Ucs(ads_point p, ads_point q, Adesk::Boolean vec);

Adesk::Boolean acdbWcs2Ecs(ads_point p, ads_point q, ads_point norm, 
			   Adesk::Boolean vec);

Adesk::Boolean acdbUcs2Wcs(ads_point p, ads_point q, Adesk::Boolean vec);

Adesk::Boolean acdbUcs2Ecs(ads_point p, ads_point q, ads_point norm, 
			   Adesk::Boolean vec);

Adesk::Boolean acdbEcs2Wcs(ads_point p, ads_point q, ads_point norm, 
			   Adesk::Boolean vec);

Adesk::Boolean acdbEcs2Ucs(ads_point p, ads_point q, ads_point norm, 
			   Adesk::Boolean vec);

Adesk::Boolean acdbUcsMatrix(AcGeMatrix3d& mat);

#endif
