#ifndef AC_DBBOILER_H
#define AC_DBBOILER_H
//
// $Id: dbboiler.h,v 1.2 1995/09/15 18:21:57 jamesr Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary
// to Autodesk,  Inc.,  and considered a trade secret as defined
// in section 499C of the penal code of the State of California.
// Use of  this information  by  anyone  other  than  authorized
// employees of Autodesk, Inc.  is granted  only under a written
// non-disclosure agreement,  expressly  prescribing  the  scope
// and manner of such use.
//
// DESCRIPTION: Main Exported Database Library Definitions.
//     Macros primarily used in the api headers

#include "rxboiler.h"

// Macro for common declarations of classes derived from
// AcDbObject which are built into AutoCAD.
//
// This macro is NOT intended for application-defined classes derived
// from AcDbObject when declaring their class header.  This macro declares
// an internally used form of constructor, which takes the
// AcDbSystemInternals* argument.  Rx applications should not define
// such constructors for their database object classes, but they should
// be ignored by the system anyway.
//
// Application-defined classes are advised to use the ACRX_DECLARE_MEMBERS
// macro instead, and to consult the documentation for related definitions.
//
#define ACDB_DECLARE_MEMBERS(CLASSNAME) \
private: \
    friend class AcDbSystemInternals; \
protected: \
    CLASSNAME(AcDbSystemInternals*); \
public: \
    ACRX_DECLARE_MEMBERS(CLASSNAME)

#define MAKE_ACDBOPENOBJECT_FUNCTION(CLASSNAME) \
inline Acad::ErrorStatus acdbOpenObject( \
    CLASSNAME*& pObj, AcDbObjectId id, AcDb::OpenMode mode, \
    Adesk::Boolean openErased = Adesk::kFalse) \
{ \
    AcDbObject* pObject; \
    Acad::ErrorStatus es = acdbOpenAcDbObject(pObject, id, mode, openErased); \
    if (es == Acad::eOk) { \
	pObj = CLASSNAME::cast(pObject); \
	if (pObj == NULL) { \
	    es = Acad::eNotThatKindOfClass; \
	    if (pObject->close() != Acad::eOk) \
		acrx_abort(/*MSG0*/"Failed AcDbObject::close()"); \
	} \
    } \
    return es; \
}

#endif
