#ifndef AD_DBDATE_H
#define AD_DBDATE_H
//
// $Id: dbdate.h,v 1.10 1995/12/20 15:11:20 neb Exp $
//
// (C) Copyright 1994-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary
// to Autodesk,  Inc.,  and considered a trade secret as defined
// in section 499C of the penal code of the State of California.
// Use of  this information  by  anyone  other  than  authorized
// employees of Autodesk, Inc.  is granted  only under a written
// non-disclosure agreement,  expressly  prescribing  the  scope
// and manner of such use.
//
// DESCRIPTION: API for date class.

#include "acdb.h"

#ifdef target
#undef target
#endif

class AcDbDwgFiler;

class AcDbDate
{
public:

    AcDbDate();
    AcDbDate(const AcDbDate&);
    virtual ~AcDbDate();

    AcDbDate& operator= (const AcDbDate&);

    long julianDay() const;
    long msecsPastMidnight() const;
 
    void getDate(short& month, short& day, short& year) const;
    short month() const;
    short day() const;
    short year() const;
    void getTime(short& hour, short& min, short& sec, short& msec) const;
    short hour() const;
    short minute() const;
    short second() const;
    short millisecond() const;
 
    void setJulianDay(long julianDay);
    void setMsecsPastMidnight(long msec);
    void setJulianDate(long julianDay, long msec);
 
    void setDate(short month, short day, short year);
    void setTime(short hour, short min, short sec, short msec);
    void setMonth(short);
    void setDay(short);
    void setYear(short);
    void setHour(short);
    void setMinute(short);
    void setSecond(short);
    void setMillisecond(short);
 
    double julianFraction() const;
    void setJulianFraction(double);

    Adesk::Boolean operator== (const AcDbDate&) const;
    // AcDbDate operator+ (const AcDbDate&) const;
    // AcDbDate operator- (const AcDbDate&) const;
    virtual AcDbDate & add (const AcDbDate &date);
    virtual AcDbDate & subtract (const AcDbDate &date);

    Adesk::Boolean isNormalized() const;
    void normalize();

    Acad::ErrorStatus dwgOut(AcDbDwgFiler *outFiler) const;
    Acad::ErrorStatus dwgIn(AcDbDwgFiler *inFiler);

private:
    friend class AcDbImpDate;
    AcDbImpDate *mpImpDate;
};

#endif
