/* $Id: dbfcf.h,v 1.26 1995/09/30 15:27:39 jamesr Exp $ */

#ifndef DBFCF_H
#define DBFCF_H
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary
// to Autodesk,  Inc.,  and considered a trade secret as defined
// in section 499C of the penal code of the State of California.
// Use of  this information  by  anyone  other  than  authorized
// employees of Autodesk, Inc.  is granted  only under a written
// non-disclosure agreement,  expressly  prescribing  the  scope
// and manner of such use.
//
// DESCRIPTION:
//
// The AcDbFcf class represents a geometric tolerance as defined by
// ANSI Y14.5

#include "dbmain.h"

class AcDbFcf: public  AcDbEntity
{
public:
    ACDB_DECLARE_MEMBERS(AcDbFcf);
                              AcDbFcf          ();
                              AcDbFcf          (const char*,
			                        const AcGePoint3d&,
						const AcGeVector3d&,
						const AcGeVector3d&);
    virtual                  ~AcDbFcf          ();

    // Required for AcDbEntity protocol.
    //
    virtual Acad::ErrorStatus getGripPoints    (AcGePoint3dArray&,
                                                AcDbIntArray&,
						AcDbIntArray&) const;
    virtual  Acad::ErrorStatus moveGripPointsAt(const AcDbIntArray&,
	const AcGeVector3d&);
    virtual void              list             () const;

    // Geometric or visual properties.
    
    virtual void              setText          (const char*);
    virtual void              setLocation      (const AcGePoint3d&);
    virtual AcGePoint3d       location         () const;
    virtual void              setOrientation   (const AcGeVector3d& norm,
						const AcGeVector3d& dir);
    virtual  AcGeVector3d normal() const;
    virtual AcGeVector3d      direction        () const;
    
    virtual  void getBoundingPoints(AcGePoint3dArray&) const;
    
    virtual void              setDimensionStyle(AcDbHardPointerId);
    virtual  AcDbHardPointerId dimensionStyle() const;
    virtual void              setDimVars();
    virtual void              edit             ();

};
MAKE_ACDBOPENOBJECT_FUNCTION(AcDbFcf);

#endif
