#ifndef _AD_DBID_OPS_H
#define _AD_DBID_OPS_H 1
// 
// $Id: dbid_ops.h,v 1.2 1995/08/19 22:53:48 jamesr Exp $
//
// (C) Copyright 1995 by Autodesk, Inc. 
// 
// The information contained herein is confidential, proprietary 
// to Autodesk,  Inc.,  and considered a trade secret as defined
// in section 499C of the penal code of the State of California. 
// Use of  this information  by  anyone  other  than  authorized
// employees of Autodesk, Inc.  is granted  only under a written 
// non-disclosure agreement,  expressly  prescribing  the  scope 
// and manner of such use. 
//
// DESCRIPTION:
//
// This file declares functions called by the app versions of the comparison
// operators of class AcDbObjectId.  This file currently contains the c4 
// versions of these functions and will be updated to contain c5 versions
// of these functions.  Adjacent apps that compile against c4 will thus not
// experience behavioral changes when c5 AutoCAD ships.  However, by 
// recompiling against c5, adjacent apps can pick up the modified behavior 
// of these operators, as the operators themselves will be modified to
// call the new functions in the header dbidapps.h
//
// Presumably, this file will be eliminated, and these functions will be
// collapsed back into dbid.h as inlines, at a later date.
//
// For further description of the AcDbObjectId types, see dbid.h

#include "adesk.h"

Adesk::Boolean
c4ObjIdIsLessThan(unsigned long lhs, unsigned long rhs); 

Adesk::Boolean
c4ObjIdIsGreaterThan(unsigned long lhs, unsigned long rhs); 

Adesk::Boolean
c4ObjIdLessThanOrEqual(unsigned long lhs, unsigned long rhs); 

Adesk::Boolean
c4ObjIdGreaterThanOrEqual(unsigned long lhs, unsigned long rhs); 

Adesk::Boolean
c4ObjIdIsEqualTo(unsigned long lhs, unsigned long rhs); 

Adesk::Boolean
c4ObjIdNotEqualTo(unsigned long lhs, unsigned long rhs); 

#endif
