// $Id: dbsubeid.h,v 1.12 1995/09/30 15:29:30 jamesr Exp $

#ifndef GEOMENT_DBSUBEID_H
#define GEOMENT_DBSUBEID_H

//*****************************************************************************
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary
// to Autodesk,  Inc.,  and considered a trade secret as defined
// in section 499C of the penal code of the State of California.
// Use of  this information  by  anyone  other  than  authorized
// employees of Autodesk, Inc.  is granted  only under a written
// non-disclosure agreement,  expressly  prescribing  the  scope
// and manner of such use.
//
// CREATED BY:  Jiri Kripac                     April-6-1993
//
// DESCRIPTION:
//
//*****************************************************************************

#include "acdb.h"
#include "dbidar.h"

class AcDbSubentId
{
public:
    AcDbSubentId();
    AcDbSubentId(AcDb::SubentType type, int index);

    Adesk::Boolean operator ==(const AcDbSubentId& id) const;
    Adesk::Boolean operator !=(const AcDbSubentId& id) const;

    AcDb::SubentType type () const;
    int              index() const;
    
private:
    AcDb::SubentType mType;
    int              mIndex;
};


extern
#ifdef _MSC_VER
    // On Dos and NT/Win builds, the Arx app needs to declare
    // all data exported from acad as dllimport, so the data
    // will be accessed indirectly.  This causes a warning
    // about changing the linkage when compiling acad, but
    // for now we can ignore that.
    /*DLLIMPORT*/  __declspec(dllimport)
#endif

const AcDbSubentId kNullSubentId;
const int kNullSubentIndex = 0;

class AcDbFullSubentPath
{
public:
    AcDbFullSubentPath();
    AcDbFullSubentPath(AcDb::SubentType type, int index);
    AcDbFullSubentPath(AcDbObjectId entId, AcDb::SubentType type, int index);
    AcDbFullSubentPath(AcDbObjectId entId, AcDbSubentId subId);
    AcDbFullSubentPath(AcDbObjectIdArray objectIds, AcDbSubentId subId);
    AcDbFullSubentPath(const AcDbFullSubentPath&);
    ~AcDbFullSubentPath();

    // Copy operator.
    //
    AcDbFullSubentPath& operator =  (const AcDbFullSubentPath&);


    Adesk::Boolean operator ==(const AcDbFullSubentPath& id) const;
    Adesk::Boolean operator !=(const AcDbFullSubentPath& id) const;

    void                objectIds(AcDbObjectIdArray& objectIds) const;
    AcDbObjectIdArray&  objectIds();
    const AcDbSubentId  subentId () const;
    AcDbSubentId&       subentId ();
    
private:                            
    AcDbObjectIdArray mObjectIds;
    AcDbSubentId      mSubentId;
};

#endif
