#ifndef AD_DBXLINE_H
#define AD_DBXLINE_H 1
//
// $Id: dbxline.h,v 1.6 1995/09/15 18:25:29 jamesr Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary
// to Autodesk,  Inc.,    and considered a trade secret as defined
// in section 499C of the penal code of the State of California.
// Use of  this information  by  anyone  other    than  authorized
// employees of Autodesk, Inc.    is granted  only under a written
// non-disclosure agreement,  expressly  prescribing  the  scope
// and manner of such use.
//
// DESCRIPTION: Exported AcDbXline Entity class

#include "dbmain.h"
#include "dbcurve.h"

class AcGePoint3d;
class AcGeVector3d;

class AcDbXline: public AcDbCurve
{
public:
    AcDbXline();
    ~AcDbXline();
    ACDB_DECLARE_MEMBERS(AcDbXline);
    DBCURVE_METHODS

    AcGePoint3d      basePoint() const;
    void             setBasePoint(const AcGePoint3d& pt); 

    AcGeVector3d     unitDir() const;
    void             setUnitDir(const AcGeVector3d& vec);
};
MAKE_ACDBOPENOBJECT_FUNCTION(AcDbXline);

#endif
