#ifndef ACDB_XRECORD_H
#define ACDB_XRECORD_H

//
// $Id: dbxrecrd.h,v 1.6 1995/12/20 15:11:35 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary
// to Autodesk,  Inc.,	and considered a trade secret as defined
// in section 499C of the penal code of the State of California.
// Use of  this information  by  anyone  other	than  authorized
// employees of Autodesk, Inc.	is granted  only under a written
// non-disclosure agreement,  expressly  prescribing  the  scope
// and manner of such use.
//
// XRECORD.H
//
// CREATED BY: Bill Adkison                    Feb 1995
//
// DESCRIPTION: AcDbXrecord class definition.
//

#define ACDB_XRECORD_CLASS          /*MSG0*/"AcDbXrecord"
#define ACDB_XRECORD_ITERATOR_CLASS /*MSG0*/"AcDbXrecordClass"

#include "dbmain.h"

class AcDbXrecord: public AcDbObject
{
public:
    ACDB_DECLARE_MEMBERS(AcDbXrecord);

    // Constructors and destructor

    AcDbXrecord();
    virtual ~AcDbXrecord();

    // AcDbXrecord Members.

    // auxDb parameter only useded when working with
    // non-Database-resident instances.

    Acad::ErrorStatus rbChain(resbuf** ppRb,
			      AcDbDatabase* auxDb = NULL) const;

    Acad::ErrorStatus setFromRbChain(resbuf& pRb,
				     AcDbDatabase* auxDb = NULL);

    Adesk::Boolean    isXlateReferences();
    void              setXlateReferences(Adesk::Boolean translate);

    // Overridden methods from AcDbObject

    virtual Acad::ErrorStatus subClose();

    virtual Acad::ErrorStatus dwgInFields(AcDbDwgFiler* filer);
    virtual Acad::ErrorStatus dwgOutFields(AcDbDwgFiler* filer) const;

    virtual Acad::ErrorStatus dxfInFields(AcDbDxfFiler* filer);
    virtual Acad::ErrorStatus dxfOutFields(AcDbDxfFiler* filer) const;

};

class AcDbImpXrecordIterator;

class AcDbXrecordIterator: public AcRxObject
{
public:
    ACRX_DECLARE_MEMBERS(AcDbXrecordIterator);
 
    AcDbXrecordIterator(const AcDbXrecord* pXrecord);
    virtual ~AcDbXrecordIterator();

    void                start();
    Adesk::Boolean      done() const;
    Acad::ErrorStatus   next();
    int                 curRestype() const;
    Acad::ErrorStatus   getCurResbuf(resbuf& outItem, AcDbDatabase* db) const;

protected:
    AcDbXrecordIterator() {};
private:
    friend class AcDbXrecord;
    friend class AcDbImpXrecord;
    AcDbImpXrecordIterator* mpImpIter;
};

#endif
