#ifndef AC_GEAPLN3D_H
#define AC_GEAPLN3D_H
//
// $Id: geapln3d.h,v 1.2 1995/10/26 16:32:32 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeAugPolyline3d - A mathematical entity
// used to represent a different types of spline curves in 3-space.

#include "gecurv3d.h"
#include "gekvec.h"
#include "gept3dar.h"
#include "gevc3dar.h"
#include "gevec3d.h"
#include "gepnt3d.h"
#include "geplin3d.h"


class AcGeAugPolyline3d : public AcGePolyline3d
{
public:

    AcGeAugPolyline3d();
    AcGeAugPolyline3d( const AcGeAugPolyline3d& src );
    AcGeAugPolyline3d( const AcGeKnotVector& knots,
                       const AcGePoint3dArray& cntrlPnts,
                       const AcGeVector3dArray& vecBundle );
    AcGeAugPolyline3d( const AcGePoint3dArray& cntrlPnts,
                       const AcGeVector3dArray& vecBundle );


    // Vector bundle 
    //
    AcGeVector3d       getVector   (int idx) const;
    AcGeAugPolyline3d& setVector   (int idx, AcGeVector3d pnt);

    // Assignment operator.
    //
    AcGeAugPolyline3d& operator =     (const AcGeAugPolyline3d&);

protected:

    friend class AcGeImpAugPolyline3d;

    // Construct object from its corresponding implementation object.
    AcGeAugPolyline3d (AcGeImpAugPolyline3d&, int);
    AcGeAugPolyline3d (AcGeImpAugPolyline3d*);
};

#endif
