#ifndef AC_GEASSIGN_H
#define AC_GEASSIGN_H
//
// $Id: geassign.h,v 1.1 1995/08/01 13:17:01 tomba Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary
// to Autodesk,  Inc.,  and considered a trade secret as defined
// in section 499C of the penal code of the State of California.
// Use of  this information  by  anyone  other  than  authorized
// employees of Autodesk, Inc.  is granted  only under a written
// non-disclosure agreement,  expressly  prescribing  the  scope
// and manner of such use.
//
// DESCRIPTION:
//
//     Useful macros for converting from various C-struct definitions
//     of points and vectors to their equivalent acgelib definitions.
//
//     This header file should ONLY be included in source files,
//     never headers as it is only intended to be an internal utility
//     for interfacing to old AutoCad C-code and other 3rd party libraries.

class AcGePoint2d;
class AcGeVector2d;
class AcGePoint3d;
class AcGeVector3d;

inline AcGePoint2d&
asPnt2d(const double* pnt)
{
    return *((AcGePoint2d*)pnt);
}

inline AcGeVector2d&
asVec2d(const double* vec)
{
    return *((AcGeVector2d*)vec);
}

inline double*
asDblArray(const AcGePoint2d& pnt)
{
    return (double*)&pnt;
}

inline double*
asDblArray(const AcGeVector2d& vec)
{
    return (double*)&vec;
}

inline AcGePoint3d&
asPnt3d(const double* pnt)
{
    return *((AcGePoint3d*)pnt);
}

inline AcGeVector3d&
asVec3d(const double* vec)
{
    return *((AcGeVector3d*)vec);
}

inline double*
asDblArray(const AcGePoint3d& pnt)
{
    return (double*)&pnt;
}

inline double*
asDblArray(const AcGeVector3d& vec)
{
    return (double*)&vec;
}

#endif
