#ifndef AC_GEBNDPLN_H
#define AC_GEBNDPLN_H
//
// $Id: gebndpln.h,v 1.5 1995/12/20 15:16:41 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeBoundedPlane - A mathematical entity 
// used to represent a 4-side bounded plane in 3-space.

#include "geplanar.h"
#include "geplane.h"

class AcGePlane;
class AcGeVector3d;
class AcGePoint3d;
class AcGePoint2d;
class AcGeLineSeg3d;

class AcGeBoundedPlane : public AcGePlanarEnt
{
public:
    AcGeBoundedPlane();
    AcGeBoundedPlane(const AcGeBoundedPlane&);
    AcGeBoundedPlane(const AcGePoint3d&, const AcGeVector3d& uVec, 
                     const AcGeVector3d& vVec);
    AcGeBoundedPlane(const AcGePoint3d&, const AcGePoint3d& origin, 
                     const AcGePoint3d&);

    // Intersection.
    //
    Adesk::Boolean    intersectWith (const AcGeLinearEnt3d&, AcGePoint3d&,
                                     const AcGeTol& = AcGeContext::gTol) const;
    Adesk::Boolean    intersectWith (const AcGePlane&, AcGeLineSeg3d&,
                                     const AcGeTol& = AcGeContext::gTol) const;
    Adesk::Boolean    intersectWith (const AcGeBoundedPlane&, AcGeLineSeg3d&,
                                     const AcGeTol& = AcGeContext::gTol) const;

    // Set methods.
    //
    AcGeBoundedPlane& set           (const AcGePoint3d&, 
                                     const AcGeVector3d& uVec, 
                                     const AcGeVector3d& vVec);
    AcGeBoundedPlane& set           (const AcGePoint3d&, 
                                     const AcGePoint3d& origin,
                                     const AcGePoint3d&);
    // Assignment operator.
    //
    AcGeBoundedPlane& operator =    (const AcGeBoundedPlane&);

protected:

    friend class AcGeImpBoundedPlane;

    // Construct object from its corresponding implementation object.
    AcGeBoundedPlane (AcGeImpBoundedPlane&, int);
    AcGeBoundedPlane (AcGeImpBoundedPlane*);
};

#endif
