#ifndef AC_GEDXFIO_H
#define AC_GEDXFIO_H
//
// $Id: gedxfio.h,v 1.3 1995/12/20 15:17:01 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeDwgIO - an utility class that
// performs DWG file IO.
#include "dbfiler.h"

class AcGePoint2d;
class AcGeVector2d;
class AcGeMatrix2d;
class AcGeScale2d;
class AcGePoint2dArray;
class AcGeVector2dArray;
class AcGePoint3d;
class AcGeVector3d;
class AcGeMatrix3d;
class AcGeScale3d;
class AcGePoint3dArray;
class AcGeVector3dArray;
class AcGeTol;
class AcGeInterval;
class AcGeKnotVector;
class AcGeDoubleArray;
class AcGeCurveBoundary;
class AcGePosition2d;
class AcGePointOnCurve2d;
class AcGeLine2d;
class AcGeLineSeg2d;
class AcGeRay2d;
class AcGeCircArc2d;
class AcGeEllipArc2d;
class AcGeExternalCurve2d;
class AcGeCubicSplineCurve2d;
class AcGeNurbCurve2d;
class AcGePolyline2d;
class AcGePosition3d;
class AcGePointOnCurve3d;
class AcGePointOnSurface;
class AcGeLine3d;
class AcGeRay3d;
class AcGeLineSeg3d;
class AcGePlane;
class AcGeBoundedPlane;
class AcGeCircArc3d;
class AcGeEllipArc3d;
class AcGeCubicSplineCurve3d;
class AcGeNurbCurve3d;
class AcGePolyline3d;
class AcGeAugPolyline3d;
class AcGeExternalCurve3d;
class AcGeCone;
class AcGeCylinder;
class AcGeTorus;
class AcGeExternalSurface;
class AcGeOffsetSurface;
class AcGeNurbSurface;
class AcGeExternalBoundedSurface;
class AcGeSphere;

struct AcGeDxfIO
{
	// Write to file
	//
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGePoint2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeVector2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeMatrix2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeScale2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGePoint2dArray&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeVector2dArray&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGePoint3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeVector3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeMatrix3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeScale3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGePoint3dArray&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeVector3dArray&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeTol&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeInterval&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeKnotVector&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeDoubleArray&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeCurveBoundary&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGePosition2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGePointOnCurve2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeLine2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeLineSeg2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeRay2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeCircArc2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeEllipArc2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeExternalCurve2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeCubicSplineCurve2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeNurbCurve2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGePolyline2d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGePosition3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGePointOnCurve3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGePointOnSurface&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeLine3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeRay3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeLineSeg3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGePlane&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeBoundedPlane&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeCircArc3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeEllipArc3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeCubicSplineCurve3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeNurbCurve3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGePolyline3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeAugPolyline3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeExternalCurve3d&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeCone&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeCylinder&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeTorus&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeExternalSurface&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeOffsetSurface&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeNurbSurface&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeExternalBoundedSurface&) ;
	static 
	Acad::ErrorStatus outFields(AcDbDxfFiler*, const AcGeSphere&) ;
	
	// Read from file
	//
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGePoint2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeVector2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeMatrix2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeScale2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGePoint2dArray&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeVector2dArray&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGePoint3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeVector3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeMatrix3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeScale3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGePoint3dArray&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeVector3dArray&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeTol&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeInterval&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeKnotVector&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeDoubleArray&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeCurveBoundary&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGePosition2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGePointOnCurve2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeLine2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeLineSeg2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeRay2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeCircArc2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeEllipArc2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeExternalCurve2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeCubicSplineCurve2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeNurbCurve2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGePolyline2d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGePosition3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGePointOnCurve3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGePointOnSurface&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeLine3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeRay3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeLineSeg3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGePlane&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeBoundedPlane&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeCircArc3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeEllipArc3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeCubicSplineCurve3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeNurbCurve3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGePolyline3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeAugPolyline3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeExternalCurve3d&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeCone&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeCylinder&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeTorus&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeExternalSurface&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeOffsetSurface&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeNurbSurface&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeExternalBoundedSurface&) ;
	static 
	Acad::ErrorStatus inFields(AcDbDxfFiler*, AcGeSphere&) ;
};

#endif
