#ifndef AC_GEEXTC3D_H
#define AC_GEEXTC3D_H
//
// $Id: geextc3d.h,v 1.7 1995/10/26 16:34:13 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeExternalCurve3d - A 
// representation for a curve that has its definition external to 
// gelib.

#include "gecurv3d.h"
#include "gearc3d.h"
#include "gevec3d.h"
#include "gepnt3d.h"

class AcGeLine3d;
class AcGeLineSeg3d;
class AcGeRay3d;
class AcGeEllipArc3d; 
class AcGeNurbCurve3d;
class AcGeExternalCurve2d;
class AcGeExternalCurve3d;

class AcGeExternalCurve3d : public AcGeCurve3d
{
public:
    AcGeExternalCurve3d();
    AcGeExternalCurve3d(const AcGeExternalCurve3d&);
    AcGeExternalCurve3d(void* curve3dDef, AcGe::ExternalEntityKind,
                            Adesk::Boolean makeCopy = Adesk::kTrue);

    Adesk::Boolean isLine         () const;
    Adesk::Boolean isRay          () const;
    Adesk::Boolean isLineSeg      () const;
    Adesk::Boolean isCircArc      () const;
    Adesk::Boolean isEllipArc     () const;
    Adesk::Boolean isNurbCurve    () const;

    Adesk::Boolean isDefined      () const;

	// Conversion to native gelib curve
    //
	Adesk::Boolean isNativeCurve  (AcGeCurve3d*&) const;

    void           getExternalCurve (void*&) const;

    // Type of the external curve.
    //
    AcGe::ExternalEntityKind     externalCurveKind () const;

    // Reset surface
    //
    AcGeExternalCurve3d& set      (void* curveDef, AcGe::ExternalEntityKind,
                                    Adesk::Boolean makeCopy = Adesk::kTrue);
     
    // Assignment operator
    //
    AcGeExternalCurve3d& operator = (const AcGeExternalCurve3d&);

    // Ownership of curve
    //
    Adesk::Boolean       isOwnerOfCurve   () const;
    AcGeExternalCurve3d& setToOwnCurve    ();

protected:  
    friend class AcGeImpExternalCurve3d;
    
    // Construct object from its corresponding implementation object
    //
    AcGeExternalCurve3d (AcGeImpExternalCurve3d&, int);
    AcGeExternalCurve3d (AcGeImpExternalCurve3d*);

};

#endif
