#ifndef AC_GELINE2D_H
#define AC_GELINE2D_H
//
// $Id: geline2d.h,v 1.1 1995/07/28 16:53:25 tomba Exp $
//
// (C) Copyright 1993,1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeLine2d - A mathematical entity
// used to represent an infinite line in 2-space.

#include "gelent2d.h"

class AcGeLine2d : public AcGeLinearEnt2d
{
public:
    AcGeLine2d();
    AcGeLine2d(const AcGeLine2d&);
    AcGeLine2d(const AcGePoint2d&, const AcGeVector2d&);
    AcGeLine2d(const AcGePoint2d&, const AcGePoint2d&);

    // The x-axis and y-axis lines.
    //
    static const   AcGeLine2d  kXAxis;
    static const   AcGeLine2d  kYAxis;

    // Set methods.
    //
    AcGeLine2d&    set         (const AcGePoint2d&, const AcGeVector2d&);
    AcGeLine2d&    set         (const AcGePoint2d&, const AcGePoint2d&);

    // Assignment operator.
    //
    AcGeLine2d&    operator =  (const AcGeLine2d&);

protected:

    friend class AcGeImpLine2d;

    // Construct object from its corresponding implementation object.
    AcGeLine2d (AcGeImpLine2d&, int);
    AcGeLine2d (AcGeImpLine2d*);
};

#endif
