#ifndef AC_GELNSG2D_H
#define AC_GELNSG2D_H
//
// $Id: gelnsg2d.h,v 1.2 1995/09/21 11:22:08 jamesr Exp $
//
// (C) Copyright 1993,1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeLinSeg2d - A mathematical entity
// used to represent a 2d line segment

#include "geline2d.h"

class AcGeLineSeg2d : public AcGeLinearEnt2d
{
public:
    AcGeLineSeg2d();
    AcGeLineSeg2d(const AcGeLineSeg2d&);
    AcGeLineSeg2d(const AcGePoint2d&, const AcGePoint2d&);
    AcGeLineSeg2d(const AcGePoint2d&, const AcGeVector2d&);

    // Set methods.
    //
    AcGeLineSeg2d& set          (const AcGePoint2d&, const AcGeVector2d&);
    AcGeLineSeg2d& set          (const AcGePoint2d&, const AcGePoint2d&);

    // Bisector.
    //
    void           getBisector  (AcGeLine2d&) const;

    // Barycentric combination of end points.
    //
    AcGePoint2d    baryComb     (double blendCoeff) const;

    // Definition of linear segment
    //
    AcGePoint2d    startPoint   () const;
    AcGePoint2d    midPoint     () const;
    AcGePoint2d    endPoint     () const;
    double         length       () const;
    double         length       (double fromParam, double toParam,
                                 double = AcGeContext::gTol.equalPoint())
                                const;
    // Assignment operator.
    //
    AcGeLineSeg2d& operator =  (const AcGeLineSeg2d&);

protected:

    friend class AcGeImpLineSeg2d;

    // Construct object from its corresponding implementation object.
    AcGeLineSeg2d (AcGeImpLineSeg2d&, int);
    AcGeLineSeg2d (AcGeImpLineSeg2d*);

};

#endif
