#ifndef AC_GENURB2d_H
#define AC_GENURB2d_H
//
// $Id: genurb2d.h,v 1.3 1995/10/26 16:35:14 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeNurbCurve2d - A mathematical entity
// used to represent a different types of spline curves in 3-space.

#include "gecurv2d.h"
#include "geintrvl.h"
#include "gekvec.h"
#include "gept2dar.h"
#include "gevec2d.h"
#include "gepnt2d.h"
#include "gesent2d.h"
#include "geplin2d.h"

class AcGeDoubleArray;

class AcGeNurbCurve2d : public AcGeSplineEnt2d
{
public:

    AcGeNurbCurve2d();
    AcGeNurbCurve2d( int degree, Adesk::Boolean isRationa = Adesk::kFalse );
    AcGeNurbCurve2d( const AcGeNurbCurve2d& src );
    AcGeNurbCurve2d( int degree, const AcGeKnotVector& knots,
                     const AcGePoint2dArray& cntrlPnts, 
                     Adesk::Boolean isPeriodic = Adesk::kFalse );
    AcGeNurbCurve2d( int degree, const AcGeKnotVector& knots,
                     const AcGePoint2dArray& cntrlPnts, 
                     const AcGeDoubleArray&  weights,
                     Adesk::Boolean isPeriodic = Adesk::kFalse );
    // Interpolation spline
    //
    AcGeNurbCurve2d( int degree, const AcGePolyline2d& fitPolyline,
                       Adesk::Boolean isPeriodic = Adesk::kFalse );

    int               numWeights() const;
    double            weightAt(int idx) const;
    AcGeSplineEnt2d&  setWeightAt(int idx, double val);

    Adesk::Boolean    evalMode           () const;        
    AcGeNurbCurve2d&  setEvalMode        ( Adesk::Boolean evalMode = 
                                           Adesk::kFalse );

    // Assignment operator.
    //
    AcGeNurbCurve2d&  operator =         (const AcGeNurbCurve2d&);

protected:

    friend class AcGeImpNurbCurve2d;

    // Construct object from its corresponding implementation object.
    AcGeNurbCurve2d (AcGeImpNurbCurve2d&, int);
    AcGeNurbCurve2d (AcGeImpNurbCurve2d*);
 
};

#endif
