#ifndef AC_GENURB3D_H
#define AC_GENURB3D_H
//
// $Id: genurb3d.h,v 1.4 1995/10/26 16:35:22 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGeNurbCurve3d - A mathematical entity
// used to represent a different types of spline curves in 3-space.

#include "gecurv3d.h"
#include "geintrvl.h"
#include "gekvec.h"
#include "gept3dar.h"
#include "gevec3d.h"
#include "gepnt3d.h"
#include "gesent3d.h"
#include "geplin3d.h"

class AcGeDoubleArray;

class AcGeNurbCurve3d : public AcGeSplineEnt3d
{
public:

    AcGeNurbCurve3d();
    AcGeNurbCurve3d( int degree, Adesk::Boolean isRationa = Adesk::kFalse );
    AcGeNurbCurve3d( const AcGeNurbCurve3d& src );
    AcGeNurbCurve3d( int degree, const AcGeKnotVector& knots,
                     const AcGePoint3dArray& cntrlPnts, 
                     Adesk::Boolean isPeriodic = Adesk::kFalse );
    AcGeNurbCurve3d( int degree, const AcGeKnotVector& knots,
                     const AcGePoint3dArray& cntrlPnts, 
                     const AcGeDoubleArray&  weights,
                     Adesk::Boolean isPeriodic = Adesk::kFalse );
    // Interpolation spline
    //
    AcGeNurbCurve3d( int degree, const AcGePolyline3d& fitPolyline,
                       Adesk::Boolean isPeriodic = Adesk::kFalse );

    int               numWeights() const;
    double            weightAt(int idx) const;
    AcGeSplineEnt3d&  setWeightAt(int idx, double val);

    Adesk::Boolean    evalMode           () const;        
    AcGeNurbCurve3d&  setEvalMode        ( Adesk::Boolean evalMode = 
                                           Adesk::kFalse );

    // Assignment operator.
    //
    AcGeNurbCurve3d&  operator =         (const AcGeNurbCurve3d&);

protected:

    friend class AcGeImpNurbCurve3d;

    // Construct object from its corresponding implementation object.
    AcGeNurbCurve3d (AcGeImpNurbCurve3d&, int);
    AcGeNurbCurve3d (AcGeImpNurbCurve3d*);
};

#endif
