#ifndef AC_GEPENT2D_H
#define AC_GEPENT2D_H
//
// $Id: gepent2d.h,v 1.1 1995/07/28 16:53:42 tomba Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGePointEnt2d - An abstract base
// class to represent point entities.

#include "adesk.h"
#include "geent2d.h"
#include "gepnt2d.h"

class AcGePointEnt2d : public AcGeEntity2d
{
public:

    // Return point coordinates.
    //
    AcGePoint2d     point2d     () const;

    // Conversion operator to convert to AcGePoint2d.
    //
    operator        AcGePoint2d () const;
    
    // Assignment operator.
    //
    AcGePointEnt2d& operator =  (const AcGePointEnt2d&);

protected:

    friend class AcGeImpPointEnt2d;

    // Private constructors so that no object of this class can be instantiated.
    AcGePointEnt2d ();
    AcGePointEnt2d (const AcGePointEnt2d&);

    // Construct object from its corresponding implementation object.
    AcGePointEnt2d (AcGeImpPointEnt2d&, int);
    AcGePointEnt2d (AcGeImpPointEnt2d*);
};

#endif
