#ifndef AC_GEPLIN3D_H
#define AC_GEPLIN3D_H
//
// $Id: geplin3d.h,v 1.4 1995/10/26 16:36:07 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGePolyline3d - A mathematical entity
// used to represent a different types of spline curves in 3-space.

#include "gecurv3d.h"
#include "gekvec.h"
#include "gept3dar.h"
#include "gevec3d.h"
#include "gepnt3d.h"
#include "gesent3d.h"


class AcGePolyline3d : public AcGeSplineEnt3d
{
public:

    AcGePolyline3d();
    AcGePolyline3d( const AcGePolyline3d& src );
    AcGePolyline3d( const AcGePoint3dArray& );

    // Approximate curve with polyline
    //
    AcGePolyline3d( const AcGeCurve3d& crv, double apprEps );

    // Interpolation data
    //
    int              numFitPoints () const;
    AcGePoint3d      fitPointAt   (int idx) const;
    AcGeSplineEnt3d& setFitPointAt(int idx, const AcGePoint3d&);

    // Assignment operator.
    //
    AcGePolyline3d& operator =     (const AcGePolyline3d&);

protected:

    friend class AcGeImpPolyline3d;

    // Construct object from its corresponding implementation object.
    AcGePolyline3d (AcGeImpPolyline3d&, int);
    AcGePolyline3d (AcGeImpPolyline3d*);
};

#endif

