#ifndef AC_GEPOS2D_H
#define AC_GEPOS2D_H
//
// $Id: gepos2d.h,v 1.2 1995/09/06 12:50:27 tomba Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary  to
// Autodesk,  Inc., and considered a trade secret as defined in sec-
// tion 499C of the penal code of the State of California.   Use  of
// this information by anyone other than authorized employees of Au-
// todesk, Inc. is  granted  only  under  a  written  non-disclosure
// agreement,  expressly  prescribing  the  scope and manner of such
// use.
//
// DESCRIPTION:
//
// This file contains the class AcGePosition2d - A 2d point entity.

#include "adesk.h"
#include "gepent2d.h"

class AcGePosition2d : public AcGePointEnt2d
{
public:
    AcGePosition2d ();
    AcGePosition2d (const AcGePoint2d&);
    AcGePosition2d (double x, double y);
    AcGePosition2d (const AcGePosition2d&);

    // Set point coordinates.
    //
    AcGePosition2d&  set        (const AcGePoint2d&);
    AcGePosition2d&  set        (double x, double y );
    
    // Assignment operator.
    //
    AcGePosition2d& operator =  (const AcGePosition2d&);

protected:

    friend class AcGeImpPosition2d;

    // Construct object from its corresponding implementation object.
    AcGePosition2d (AcGeImpPosition2d&, int);
    AcGePosition2d (AcGeImpPosition2d*);
};

#endif
