#ifndef AC_GEXBNDSF_H
#define AC_GEXBNDSF_H
//
// $Id: gexbndsf.h,v 1.5 1995/10/26 16:37:02 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc. 
//
// The information contained herein is confidential, proprietary  to 
// Autodesk,  Inc., and considered a trade secret as defined in sec- 
// tion 499C of the penal code of the State of California.   Use  of 
// this information by anyone other than authorized employees of Au- 
// todesk, Inc. is  granted  only  under  a  written  non-disclosure 
// agreement,  expressly  prescribing  the  scope and manner of such 
// use.
//
// Description:
//
// This files implements the AcGeExternalBoundedSurface class,
// which is a representation of the geometry associated with a
// face entity.
// 
     
#include "gegbl.h"
#include "gesurf.h"
     
class AcGeExternalSurface;
class AcGeCurveBoundary;
     
class AcGeExternalBoundedSurface : public AcGeSurface 
{
public:
   AcGeExternalBoundedSurface();
   AcGeExternalBoundedSurface(void* surfaceDef, AcGe::ExternalEntityKind,
                              Adesk::Boolean makeCopy = Adesk::kTrue);
   AcGeExternalBoundedSurface(const AcGeExternalBoundedSurface&);
     
   // Surface data.
   //
   AcGe::ExternalEntityKind   externalSurfaceKind  () const;
   Adesk::Boolean             isDefined            () const;
   void                       getExternalSurface   (void*&) const;

    // Access to unbounded surface.
    //
    void getBaseSurface        (AcGeExternalSurface&) const;

	 // Access to the boundary data.
    //
    int          numContours  () const;
    void         getContours  (int&, AcGeCurveBoundary*&) const;
      
    // Set methods
    //     
    AcGeExternalBoundedSurface& set  (void* surfaceDef,
                                      AcGe::ExternalEntityKind,
                                      Adesk::Boolean makeCopy = Adesk::kTrue);

    // Assignment operator.
    //
    AcGeExternalBoundedSurface& operator = (const AcGeExternalBoundedSurface&);  
   
    // Surface ownership.
    //
	Adesk::Boolean               isOwnerOfSurface() const;
    AcGeExternalBoundedSurface&  setToOwnSurface();
          
private:
    friend class AcGeImpExternalBoundedSurface;

	AcGeExternalBoundedSurface (AcGeImpExternalBoundedSurface&, int);
    AcGeExternalBoundedSurface (AcGeImpExternalBoundedSurface*);
};
     
#endif
