#ifndef _rxkernel_h
#define _rxkernel_h 1
//
// $Id: rxkernel.h,v 1.13 1995/10/26 17:08:09 neb Exp $
//
// (C) Copyright 1982-1992,1994,1995 by Autodesk, Inc.
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted,
// provided that the above copyright notice appears in all copies and
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.

#include "rxsrvice.h"

class AcRxClass;
class AcRxDictionary;

class AcRxKernel : public AcRxService
{
public:
    ACRX_DECLARE_MEMBERS(AcRxKernel);

    virtual
    AcRxDictionary* newAcRxDictionary(Adesk::Boolean sorted = Adesk::kTrue) = 0;

    virtual
    AcRxDictionary* newAcRxDictionary(unsigned long length,
				      Adesk::Boolean delObjects,
				      Adesk::Boolean sorted = Adesk::kTrue) = 0;
    virtual
    AcRxDictionary* newAcRxDictionary(const AcRxClass * filter) = 0;
};

#define acrxKernel \
    AcRxKernel::cast(AcRxDictionary::cast(\
    acrxSysRegistry()->at(ACRX_SERVICE_DICTIONARY))->at(ACRX_KERNEL_SERVICES)) 

#endif
