/* Next available MSG number is   1 */
/* $Id: rxregsvc.h,v 1.7 1995/10/26 16:54:56 neb Exp $ */
/*
      (C) Copyright 1982-1992,1994,1995 by Autodesk, Inc.

******************************************************************************
*                                                                            *
* The information contained herein is confidential, proprietary to Autodesk, *
* Inc., and considered a trade secret as defined in section 499C of the      *
* penal code of the State of California.  Use of this information by anyone  *
* other than authorized employees of Autodesk, Inc. is granted only under a  *
* written non-disclosure agreement, expressly prescribing the scope and      *
* manner of such use.                                                        *
*                                                                            *
******************************************************************************/


/* rxregsvc.h:  "C" Interface for registering services in Rx

CREATED BY:  Bill Adkison  Oct. 1992

*/

#ifndef _rxregsvc_h
#define _rxregsvc_h 1

#if defined(__cplusplus)
extern "C" {
#endif

/* acrxLoadModule()

   Load a module, given its file name. 
*/
   
extern int acrxLoadModule(char * moduleName, int printit);

/* acrxUnloadModule()

   UnLoad a module, given its file name.

   NOT IMPLEMENTED YET:
   Module's services and classes are queried for
   dependencies.  If all module elements have no
   dependencies, then unload can proceed.
*/

extern int acrxUnloadModule(char * moduleName);

/* acrxGetServiceSymbolAddr()

   return a void * representing a handle to the module that
   registered the service, NIL if service is not present.

   For be use in C API libraries to link up stub entry points with
   real ones.  C++ libraries can use this function as well. */
   
extern void * acrxGetServiceSymbolAddr(char * serviceName, char * symbol);


/* acrxRegisterService()

   Tell system that the service represented by serviceName string is
   present in this module.  The system registers an instance
   of AcRxService with this name, for internal use.  */

extern void * acrxRegisterService(char * serviceName);

/* acrxServiceIsRegistered()

   Return boolean indicating whether named service is registered
   and present in the system. */

extern int acrxServiceIsRegistered(char * serviceName);

/* Note: The following three prototypes are also defined adslib.h for use
   by ads-rx apps.  */ 

#ifndef _rxsvc_applockfun
#define _rxsvc_applockfun 1

/* acrxUnlockApplication()

   Unlocks an application to enable it from being unloaded in mid-session.
   The default is that applications are locked, and hence unloadable in
   mid-session. The appId argument is the Id passed in as a void* during
   the AcRx::kInitAppMsg call back when the application is loaded. Return
   of non-zero means success.

*/
extern int acrxUnlockApplication(void* appId);


/* acrxApplicationIsLocked()
  
   Returns non-zero if the specified app is locked.
*/
extern int acrxApplicationIsLocked(const char* modulename);

/* acrxLockApplication()
  
   Symmetric to acrxUnlockApplication. Locks it, and hence prevents it from
   being unloaded in mid-session. Return of non-zero means success.
*/
extern int acrxLockApplication(void* appId);

#endif /* _rxsvc_applockfun */

#if defined(__cplusplus)
}
#endif

#endif /* _rxregsvc_h */
