#ifndef ACDB_UTIL_H
#define ACDB_UTIL_H

//
// $Id: util.h,v 1.4 1995/10/26 17:20:13 neb Exp $
//
// (C) Copyright 1993-1995 by Autodesk, Inc.
//
// The information contained herein is confidential, proprietary
// to Autodesk,  Inc.,	and considered a trade secret as defined
// in section 499C of the penal code of the State of California.
// Use of  this information  by  anyone  other	than  authorized
// employees of Autodesk, Inc.	is granted  only under a written
// non-disclosure agreement,  expressly  prescribing  the  scope
// and manner of such use.
//
// UTIL.H
//
// CREATED BY: Keshav Sahoo                    May 1994
//
// DESCRIPTION: 

#include "acgi.h"


// ADS input options

#define INP_NNULL     0x01
#define INP_NZERO     0x02
#define INP_NNEG      0x04
#define INP_NLIM      0x08
#define INP_DASH      0x20
#define INP_NZCOORD   0x40

// ADS redraw types

#define RD_DRAW       1
#define RD_ERASE      2
#define RD_HILITE     3
#define RD_UNHI       4




double  rx_fixangle(double angle);

void    rx_fixindex(int& index, int maxIndex);

Adesk::Boolean rx_wc2uc(ads_point p, ads_point q, Adesk::Boolean vec);

Adesk::Boolean rx_wc2ec(ads_point p, ads_point q, ads_point norm, 
			Adesk::Boolean vec);

Adesk::Boolean rx_uc2wc(ads_point p, ads_point q, Adesk::Boolean vec);

Adesk::Boolean rx_uc2ec(ads_point p, ads_point q, ads_point norm, 
			Adesk::Boolean vec);

Adesk::Boolean rx_ec2wc(ads_point p, ads_point q, ads_point norm, 
			Adesk::Boolean vec);

Adesk::Boolean rx_ec2uc(ads_point p, ads_point q, ads_point norm, 
			Adesk::Boolean vec);

Adesk::Boolean rx_ucsmat(AcGeMatrix3d& mat);

Acad::ErrorStatus postToDb(AcDbEntity* ent);
Acad::ErrorStatus addToDb(AcDbEntity* ent);

Acad::ErrorStatus postToDb(AcDbEntity* ent, AcDbObjectId& objId);
Acad::ErrorStatus addToDb(AcDbEntity* ent, AcDbObjectId& objId);

Acad::ErrorStatus rx_scanPline(AcDb2dPolyline*        pline,
		               AcGePoint3dArray&         points,
		               AcGeDoubleArray&       bulges);

Acad::ErrorStatus rx_scanPline(AcDb3dPolyline*        pline,
		               AcGePoint3dArray&         points);

Acad::ErrorStatus rx_makeArc(const AcGePoint3d   pt1, 
			     const AcGePoint3d   pt2, 
			     double              bulge,
			     AcGeCircArc3d&      arc);

Acad::ErrorStatus rx_makePline(const AcGePoint3dArray&     pts,
                               const AcGeMatrix3d&      mat,
			       AcDb2dPolyline*&         pline);

Acad::ErrorStatus rx_makePline(const AcGePoint3dArray&     pts,
			       AcDb2dPolyline*&         pline);

Acad::ErrorStatus rx_makePline(const AcGePoint3dArray&     pts,
                               const AcGeDoubleArray&   bulges,
                               const AcGeMatrix3d&      mat,
			       AcDb2dPolyline*&         pline);

Acad::ErrorStatus rx_makePline(const AcGePoint3dArray&     pts,
                               const AcGeDoubleArray&   bulges,
			       AcDb2dPolyline*&         pline);

Acad::ErrorStatus rx_makePline(const AcGePoint3dArray&     pts,
			       AcDb3dPolyline*&         pline);

Acad::ErrorStatus rx_makeArc(const AcGePoint3d   pt1, 
			     const AcGePoint3d   pt2, 
			     double              bulge,
			     const AcGeVector3d  entNorm,
			     AcGeCircArc3d&      arc);

// Given the name of a text style, see if it can be found
// in the current database and get its db id if so.
//
Acad::ErrorStatus rx_getTextStyleId(const char *styleName,
                                    AcDbDatabase *db,
                                    AcDbObjectId &styleId);

// Given the db id of an AcDbTextStyleTableRecord, construct
// an AcGiTextStyle structure out of that text style.
//
Acad::ErrorStatus rx_getTextStyle(AcGiTextStyle &ts,
                                  AcDbObjectId styleId);

#endif /*ACDB_UTIL_H*/
